#ifndef STR_H
#define STR_H

//==== Includes

//-- self

#include "Types.h"


//==== Functions

//-- declarations

int str_to_int(const char* text);

//-- definitions

static inline void strdelete(char* text)
{
	delete[] text;
}

static inline bool strequal(const char* text1, const char* text2)
{
	// if (text1 == text2) return true;
	// if (text1 == nullptr || text2 == nullptr) return false;

	char c;
	while (*text2++ == (c = *text1++))
	{
		if (c == '\0') return true;
	}
	return false;
}

static inline size_t strlength(const char* text)
{
	size_t len = 0;
	// if (text != nullptr)
	{
		while (*text++ != '\0') len++;
	}
	return len;
}

static inline char* strappend(char* pos, const char* text)
{
	// if (text != nullptr)
	{
		while ((*pos++ = *text++) != '\0');
		pos--;
	}
	return pos;
}

static inline char* strcopy(const char* text)
{
	char* copy = new char[strlength(text) + 1];
	strappend(copy, text);
	return copy;
}

static inline char* strnew(const char* text1, const char* text2)
{
	char* merged = new char[strlength(text1) + strlength(text2) + 1];
	strappend(strappend(merged, text1), text2);
	return merged;
}

template<size_t L>
static inline bool lstrequal(char (&lstr)[L], const char* text2)
{
	char* text1 = &lstr[0];
	size_t len = L;

	// if (text1 == text2) return true;
	// if (text1 == nullptr || text2 == nullptr) return false;

	while (len --> 0)
	{
		char c;
		if (*text2++ != (c = *text1++)) return false;
		if (c == '\0') break;
	}

	return true;
}

template<size_t L>
static inline void lstrset(char (&lstr)[L], const char* src)
{
	char* text = &lstr[0];
	// if (src == nullptr) { *text = '\0'; return; }

	size_t len = L;
	while (len --> 0)
	{
		if ((*text++ = *src++) == '\0') break;
	}
}

template<size_t L>
static inline void lstrpad(char (&lstr)[L], char pad)
{
	char* text = &lstr[0];

	size_t len = L;
	while (len --> 0)
	{
		if (*text == '\0')
		{
			do
			{
				*text = pad;
			}
			while (len --> 0);

			break;
		}
		text++;
	}
}

template<size_t L>
static inline void lstrreplace(char (&lstr)[L], char before, char after)
{
	char* text = &lstr[0];
	size_t len = L;
	while (len --> 0)
	{
		if (*text == before) *text = after;
		text++;
	}
}

#endif /* STR_H */